DÉCLARATION DE KASPERSKY SECURITY NETWORK (KSN)
La Déclaration de Kaspersky Security Network (ci-après « Déclaration KSN ») porte sur Kaspersky Endpoint Security for Linux (ci-après « Logiciel »).
L’ensemble des termes de la présente Déclaration KSN ont la même définition que celle qui leur est donnée dans la clause « Définitions » du Contrat de licence utilisateur final (CLUF).
La Déclaration KSN et le Contrat de licence utilisateur final du Logiciel, notamment dans la section « Conditions concernant le traitement des données », spécifient les conditions, les responsabilités et les procédures relatives à la transmission et au traitement des données, comme indiqué dans la Déclaration KSN. Avant de l’accepter, lisez attentivement les conditions de la Déclaration KSN, ainsi que tous les documents qui y sont mentionnés.
Lorsque l’Utilisateur final active l’utilisation de KSN, il incombe à l’Utilisateur final de s’assurer que le traitement des données personnelles des Personnes concernées est légal, en particulier, conformément à l’Article 6 (1) (a) à (1) (f) du Règlement (UE) 2016/679 (Règlement général sur la protection des données, « RGPD ») si la Personne concernée par les données se trouve dans l’Union européenne, ou aux lois en vigueur sur les informations confidentielles, les données personnelles, la protection des données, etc.
Traitement et protection des données
Le Titulaire des droits gère les données qu’il reçoit de l’Utilisateur final en vertu de la présente Déclaration, conformément à la Politique de confidentialité du Titulaire des droits publiée à l’adresse https://www.kaspersky.com/Products-and-Services-Privacy-Policy.
Objectif du traitement des données
Augmenter la réactivité du Logiciel face aux menaces de sécurité pesant sur le réseau et les informations.
L’objectif déclaré est atteint en :
- déterminant la réputation des objets analysés ;
- identifiant les nouvelles menaces de sécurité des informations, difficiles à détecter, ainsi que leurs sources ;
- prenant rapidement les mesures nécessaires pour accroître la protection des données stockées et traitées par l’Utilisateur final à l’aide de l’Ordinateur ;
- réduisant la probabilité de faux positifs ;
- améliorant l’efficacité des composants logiciels ;
- conduisant une enquête en cas d’infection de l’ordinateur d’un utilisateur ;
- améliorant les performances des produits du Détenteur des droits ;
- recevant des informations de référence sur le nombre d'objets dont la réputation est éprouvée.
Données traitées
Lorsque KSN est activé, le Titulaire des droits reçoit et traite automatiquement des données suivantes :
un indicateur signalant une application qui s'exécute automatiquement au démarrage; droits d'accès concernant l'objet en cours de traitement; adresse d’accès du service web (URL, IP); adresse IPv4 consultée du service Web; adresse IPv6 consultée du service Web; algorithme de calcul de l'empreinte du certificat numérique; taille de l'image de l'application; attribut d'un objet en cours de traitement ayant autorisé à se rappeler de la décision de faux positive concernant l'objet; attributs du fichier exécutable en cours de traitement; masque binaire d'options de la requête DNS; masque binaire des paramètres de l'objet en cours de traitement; masque de bits de la section de répertoires de données dans le fichier PE; algorithme de calcul de la clé publique du certificat; nom de l'émetteur du certificat; nom et paramètres du propriétaire du certificat; numéro de série du certificat; somme de contrôle (MD5) du masque bloquant le service Web; somme de contrôle (MD5) de l'objet en cours de traitement; somme de contrôle (SHA256) de l'objet en cours de traitement; somme de contrôle de l'objet en cours de traitement; somme de contrôle du code d’activation du Logiciel; somme de contrôle du fichier clé du Logiciel; somme de contrôle du nom d'utilisateur; type de somme de contrôle pour l'objet en cours de traitement; code de la catégorie d'erreur; ligne de commande; arguments de ligne de commande pour le processus; nom de composant; nom de l'utilisateur sur le réseau (nom de domaine); caractère confidentiel de la détection d'accès au service Web de phishing; ID du ticket à propos de la licence actuelle; données à propos de la licence pour identifier un groupe d’utilisateurs de l’entreprise qui a acquis la licence par les commentaires dans les propriétés de licence; données du journal interne, générées par le module du Logiciel antivirus pour un objet en cours de traitement; date et heure de création d'un fichier exécutable en cours de traitement; date et heure de création d'un objet en cours de traitement; date et heure de la détection de logiciel par System Watcher; date et heure de l'association du fichier exécutable; date et heure de la signature de l'objet; date et heure de la dernière modification de l'objet en cours de traitement; date et heure de début de réception des statistiques; date et heure de fin de réception des statistiques; date et heure d'expiration du certificat; date et heure de l'émission du certificat; indicateur de détection de débogage; retard dans l'envoi des statistiques; description d'un objet en cours de traitement tel que défini dans les propriétés de l'objet; caractéristiques de la détection; opérations de fichiers détectées concernant l'objet en cours de traitement; ID du périphérique; empreinte du pouce du certificat numérique de l'objet scanné et algorithme de hachage; direction d'une connexion réseau; code de répertoire; adresse DNS du service Web en cours d’accès; réponse du serveur DNS; profondeur de l'émulation; version de l'émulateur; caractéristiques du chiffrement du package de données en cours d'envoi vers KSN; entropie du fichier en cours de traitement; code d'erreur; code d'erreur de la tâche de mise à jour; date et heure de l’évènement; adresse IP externe; attributs de fichier d'un objet en cours de traitement; code d'opération de fichier; indicateur précisant si la participation au KSN est activée; indicateur précisant si l'objet en cours de traitement est un fichier PE; format des données dans la demande de l'infrastructure du Détenteur des droits; format de l'objet en cours de traitement; contenu en fragments de l'objet en cours de traitement; ordre des fragments dans l'objet en cours de traitement; version complète du Logiciel; en-tête de la demande http en cours de traitement; nom dérivé heuristiquement du marketer par email - expéditeur du message électronique; source d’hébergement; méthode de demande http; ID d'un centre d'activation régional; ID du package de données en cours d'envoi vers KSN; ID du compte utilisé pour démarrer le processus contrôlé; ID du modèle d’informations utilisé pour fournir la licence du Logiciel; identifiant de la clé du fichier de clés utilisé pour le cryptage; identifiant du service KSN auquel le Logiciel a accédé; ID du Logiciel sous licence; ID de l’opération que le Logiciel est en train d’effectuer; ID de l'opération en cours sur le logiciel tiers; ID de la tâche dans le cadre de laquelle la détection a été effectuée; identifiant de la signature déclenchée dans les bases de données antivirus du Logiciel; identifiant du certificat utilisé pour signer l’en-tête du ticket à propos de la licence du Logiciel; identifiant de l’organisation partenaire via laquelle la commande de licence du Logiciel a été effectuée; indicateur indiquant que le message fait partie d’un bundle de messages appartenant à un accès au service Web; informations sur les résultats de la vérification de la signature des fichiers; informations à propos des mises à jour du Logiciel; informations à propos du client utilisant un protocole réseau (agent de l'utilisateur); informations sur la personne ayant signé le fichier en cours de traitement; date et heure d’installation du Logiciel; niveau d'intégrité de l'objet en cours de traitement; Adresse IP; adresse IP de l’ordinateur à l’origine de l’attaque; adresse IP du serveur DNS; date d'expiration de la licence; identifiant de la licence; adresse IP locale; port local ayant été victime d'une attaque; emplacement d'injection du code dans le processus; clé de la session ouverte; algorithme de cryptage de la clé de la session ouverte; adresse MAC de la source de l'attaque réseau; nom du protocole réseau utilisé dans le cadre de l'attaque réseau détectée; nom du service SE créé/modifié; nom de l’application malveillante ou du logiciel authentique détecté  qui peut être utilisé pour endommager l’appareil ou les données de l’utilisateur; nom de l'objet en cours de traitement; noms des utilitaires de compression ayant compressé l'objet en cours de traitement; liste des interfaces réseau de l'ordinateur; type de notification qui a déclenché l’envoi de statistiques; nombre d'échecs d'installation de mises à jour pour le composant du programme de mise à jour; nombre de connexions KSN prélevées à partir du cache; nombre de nouvelles connexions à KSN; nombre de requêtes pour lesquelles une réponse a été trouvée dans la base de données des requête locales; nombre de sections dans le fichier PE; nombre d’exécutions du logiciel depuis le dernier envoi du fichier de somme de contrôle; nombre de connexions abouties à KSN; nombre de transactions KSN abouties; nombre de logiciels détectés dans le cadre de System Watcher; nombre de connexions KSN ayant échoué; nombre de transactions KSN ayant échoué; nombre de demandes non abouties causées par la désactivation de KSN dans les paramètres du Logiciel; nombre de demandes non abouties à KSN causées par des problèmes de réseaux; nombre de demandes non abouties à KSN causées par des erreurs de routage; nombre d'erreurs d'installation de mises à jour pour le composant du programme de mise à jour; date et heure de l’objet dans la mémoire tampon; code du type d'objet; objets ou ses parties en cours de traitement; état de fonctionnement du composant du Logiciel; version bit du système d’exploitation, architecture du système d’exploitation; édition du SE; ID du SE; version du Service Pack du système d'exploitation; version du système d’exploitation, numéro de version du système d’exploitation, numéro de mise à jour du système d’exploitation, édition du système d’exploitation, informations détaillées relatives à l’édition du système d'exploitation, version du noyau du système d’exploitation, architecture du système d’exploitation; versions du SE; la version du Logiciel; taille de superposition dans le fichier PE; nom de l'application parente; ID de système du processus parent (PID); chemin vers l'objet en cours de traitement; ID des commandes effectuées; cible d'une attaque de phishing; numéro de port; ID du système de processus (PID); propriétés et sommes de contrôle des parties du fichier d'exécution; ID de protocole; protocole utilisé pour l'échange de données avec KSN; clé public du certificat; motif de la détection de logiciels par System Watcher; date et heure de publication des bases de données du Logiciel; résultat de l'action concernant l'objet en cours de traitement; résultat de la demande de vérification; résultat de la vérification de l'intégrité du module; identifiant de zone de sécurité extrait du flux NTFS.; numéro de série de la clé de licence du Logiciel; taille de l'objet en cours de traitement; Date et heure d’activation du Logiciel; nom du composant du Logiciel; état d’intégrité du Logiciel après la mise à jour; ID du Logiciel; ID du Logiciel provenant de la licence; identifiant de l'installation du Logiciel (PCID); ID de la licence du Logiciel; localisation du Logiciel; nom du Logiciel; ID du changement d’appellation du Logiciel; ID de la mise à jour du Logiciel; nom du fournisseur du Logiciel; chemin du fichier source; source de la décision prise pour l'objet en cours de traitement; statistiques du type de message; état de la licence utilisée par le Logiciel; temps de stockage de l'objet en cours de traitement; distribution temporaire des demandes à KSN annulées; distribution temporaire des demandes à KSN ayant expiré; distribution temporaire des connexions abouties à KSN; distribution temporaire des transactions KSN abouties; distribution temporaire des demandes abouties à KSN; distribution temporaire des connexions non abouties à KSN; distribution temporaire des transactions KSN non abouties; l’identifiant de la configuration; chemin complet du fichier de processus parent utilisé pour lancer le processus; résultat de la vérification de statut dans KSN pour un objet en cours de traitement; résultat de l’action du Logiciel; version du code d’activation du Logiciel; ID de base de la catégorisation du Logiciel; ID de composant du Logiciel; ID de l’entrée de base de données du Logiciel; version de l’entrée de base de données du Logiciel; somme de contrôle du ticket à propos de la licence du Logiciel; date et heure de création du ticket à propos de la licence du Logiciel; version du ticket à propos de la licence du Logiciel; décision du Logiciel sur l'objet en cours de traitement; spécifications techniques des technologies de détection appliquées; type du compte utilisateur utilisé pour démarrer l’objet potentiellement malveillant; ID de la mise à jour du logiciel tiers; heure du premier lancement de l’objet en cours de traitement; horodatage du composant (version locale); horodatage de l'index racine des mises à jour disponibles; horodatage de l'index racine des mises à jour en cours de téléchargement; horodatage des bases de données du Logiciel; date et heure de la signature déclenchée dans les bases de données antivirus du Logiciel; horodatage du composant mis à jour (version mise à jour); nombre total de demandes à KSN; indicateur de confiance de l’objet conformément au KSN; type de requête DNS; type de la tâche d'analyse de fichiers exécutables envoyant les statistiques; type de Logiciel installé; type de signature déclenchée dans les bases de données antivirus du Logiciel; ID unique de l’appareil; identifiant unique d’événement; ID unique du journal d'activité de l'objet en cours de traitement; identifiant unique de l’Utilisateur dans le système du Détenteur des droits; type de tâche de mise à jour; identifiant de sécurité du compte utilisateur (SID); actions d'utilisateur concernant l'élément d'interface dans la fenêtre d'application; valeur de l'attribut de caractéristiques issu de l'en-tête du fichier PE; valeur de l'attribut de sous-système issu de l'en-tête du fichier PE; valeur du filtre TARGET pour les tâches de mise à jour; version d'un certain compilateur; version de la liste des décisions révoquées du service du Logiciel; version d'un objet en cours de traitement; version du système d’exploitation installée sur l’ordinateur de l’utilisateur; version du composant du Logiciel; version des statistiques en cours d'envoi; version du composant du programme de mise à jour; classe de danger de la vulnérabilité; ID de vulnérabilité; adresse Web en cours de traitement; adresse Web à partir de laquelle le fichier correspondant au processus a été téléchargé; adresse Internet de la source de la requête du service Web (référant); poids de l'accès détecté vers le service Web de phishing; index de zone dont fait partie l'adresse IP du point de terminaison.
En outre, afin d'atteindre l'objectif déclaré visant à éviter tout faux positif, le Détenteur des droits peut recevoir des fichiers exécutables et non exécutables, dans leur intégralité ou en partie.
Votre décision de participer
Le fait de fournir les informations ci-dessus à KSN est volontaire. Une fois le Logiciel installé, l’Utilisateur final peut à tout moment activer ou désactiver l’utilisation de KSN dans les paramètres du Logiciel, comme décrit dans le Manuel de l’utilisateur.
Lorsque l’Utilisateur final décide de désactiver le KSN, le Détenteur des droits ne recevra pas de nouvelles données. Le Détenteur des droits peut encore traiter certaines données déjà reçues en vertu de l’intérêt légitime conformément à l’Article 6, paragraphe 1, point f), du Règlement général sur la protection des données (RGPD) de l’UE, aux fins décrites dans la Politique de confidentialité à l’adresse https://www.kaspersky.com/Products-and-Services-Privacy-Policy. Si l’Utilisateur final souhaite refuser le traitement des données, il doit en informer le Détenteur des droits de la manière spécifiée dans la Politique de confidentialité. Pour plus d’informations sur les bases juridiques du traitement des données et les droits et options de l’Utilisateur final, ce dernier peut consulter la Politique de confidentialité à l’adresse https://www.kaspersky.com/Products-and-Services-Privacy-Policy.
© 2022 AO Kaspersky Lab
