ПОЛОЖЕНИЕ О KASPERSKY SECURITY NETWORK (KSN)

Положение о Kaspersky Security Network (далее – Положение о KSN) относится к программному обеспечению Kaspersky Endpoint Security для Linux (далее – ПО).

Все используемые в настоящем Положении определения имеют значения, указанные в Разделе «Определения» Лицензионного соглашения.

Положение о KSN совместно с Лицензионным соглашением для ПО, в частности в разделе «Условия обработки данных», определяют условия, ответственность и порядок передачи и обработки данных, указанных в Положении о KSN. Внимательно ознакомьтесь с условиями Положения о KSN, а также со всеми документами, ссылки на которые содержит Положение о KSN, перед тем, как принять его.

Если Пользователь включает использование KSN, Пользователь несет ответственность за обеспечение законности обработки персональных данных Субъектов данных, которая определена в применимых законах о конфиденциальной информации, персональных данных, защите данных или аналогичных законах.

Защита и обработка данных
Данные, которые получает Правообладатель от Пользователя при использовании KSN, защищаются и обрабатываются в соответствии с Политикой конфиденциальности Правообладателя, опубликованной по адресу: https://www.kaspersky.com/products-and-services-privacy-policy.

Цель обработки данных
Сделать возможным ускорить реакцию ПО на угрозы информационной и сетевой безопасности.
Заявленная цель достигается посредством:
– определения репутации проверяемых объектов;
– выявления новых и сложных для обнаружения угроз информационной и сетевой безопасности, а также их источников;
– оперативного принятия мер по повышению уровня защиты информации, хранимой и обрабатываемой Пользователем с использованием Компьютера;
– уменьшения вероятностей ложных срабатываний;
– повышения эффективности работы компонентов ПО;
– расследование заражения на компьютере Пользователя;
– улучшения качества работы продуктов Правообладателя;
– получения справочной информации о количестве объектов с известной репутацией.

Обрабатываемые данные
Пока использование KSN включено, Правообладатель будет получать и обрабатывать следующие данные в автоматическом режиме: DNS-адрес веб-службы, к которой осуществляется обращение; IP-адрес; IP-адрес (IPv4) веб-службы, на который осуществлялось обращение; IP-адрес (IPv6) веб-службы, на который осуществлялось обращение; IP-адрес DNS-сервера; IP-адрес атакующего; MAC-адрес источника сетевой атаки; адрес веб-службы, на который осуществлялось обрабатываемое обращение (веб-адрес, IP); алгоритм вычисления публичного ключа сертификата; алгоритм расчета отпечатка цифрового сертификата; аргументы командной строки, переданные процессу при запуске; атрибуты обрабатываемого исполняемого файла; атрибуты обрабатываемого объекта; битовая маска параметров DNS-запроса; битовая маска параметров обрабатываемого объекта; битовая маска, построенная по секции Data Directories из PE заголовка файла; веб-адрес источника запроса к веб-службе (referer); веб-адрес, с которого был загружен файл, соответствующий процессу; версия записи в базе данных ПО; версия кода активации ПО; версия компонента обновления; версия компонента ПО; версия лицензионного тикета ПО; версия обрабатываемого объекта; версия определенного компилятора; версия ОС, номер сборки ОС, номер обновления ОС, редакция ОС, расширенная информация о редакции ОС, версия ядра ОС, архитектура ОС; версия ПО; версия отправляемой статистики; версия пакета обновления ОС; версия списка отозванных заключений службы ПО; версия установленной операционной системы на компьютере пользователя, версия ядра ОС; версия эмулятора; весовая характеристика обнаруженного обращения к фишинговой веб-службе; внешний IP-адрес; временная метка баз ПО; временная метка компонента (локальная версия); временная метка компонента обновления (обновленная версия); временная метка корневого индекса загружаемых обновлений; временная метка корневого индекса имеющихся обновлений; временная метка сработавшей записи в антивирусных базах ПО; время задержки отправки статистики; время пребывания объекта в буфере; время хранения обрабатываемого объекта; глубина эмуляции; данные внутреннего журнала, сформированного антивирусным компонентом ПО для обрабатываемого объекта; данные о лицензии для идентификации группы пользователей в компании, которая приобрела лицензию, по комментарию в свойствах лицензии; дата и время активации ПО; дата и время выдачи сертификата; дата и время выпуска баз ПО; дата и время истечения сертификата; дата и время компоновки исполняемого файла; дата и время начала получения статистики; дата и время обнаружения стороннего ПО компонентом мониторинг активности; дата и время окончания получения статистик; дата и время первого запуска обрабатываемого объекта; дата и время подписи объекта; дата и время последней модификации обрабатываемого объекта; дата и время события; дата и время создания лицензионного тикета ПО; дата и время создания обрабатываемого исполняемого файла; дата и время создания обрабатываемого объекта; дата и время установки ПО; дата окончания срока действия лицензии; действия пользователя с элементом интерфейса в окне программы; заголовок обрабатываемого http-запроса; заключение ПО по обрабатываемому объекту; значение атрибута Charecteristics из PE заголовка файла; значение атрибута Subsystem из заголовка PE-файла; значение фильтра TARGET для задачи обновления; идентификатор базы категоризации ПО; идентификатор безопасности учетной записи (SID); идентификатор задачи, в рамках которой произошло обнаружение; идентификатор записи в базах ПО; идентификатор зоны безопасности из потока NTFS; идентификатор информационной модели, примененной при предоставлении лицензии на использование ПО; идентификатор ключа из хранилища ключей, используемого для шифрования; идентификатор компании партнера, у которого был размещен заказ на покупку лицензии на использование ПО; идентификатор компонента ПО; идентификатор конфигурации; идентификатор лицензии; идентификатор лицензии ПО; идентификатор обновления ПО; идентификатор обновления стороннего ПО; идентификатор операции, выполняемой ПО; идентификатор операции, выполняемой со сторонним ПО; идентификатор ОС; идентификатор пакета данных, отправляемых в KSN; идентификатор ПО; идентификатор ПО, для которого предназначена лицензия; идентификатор ПО, полученный из лицензии; идентификатор протокола; идентификатор процесса в системе (PID); идентификатор ребрендинга ПО; идентификатор регионального центра активации; идентификатор родительского процесса в системе (PID); идентификатор сертификата, которым подписан заголовок лицензионного тикета ПО; идентификатор службы KSN, к которой обращается ПО; идентификатор сработавшей записи в антивирусных базах ПО; идентификатор тикета текущей лицензии; идентификатор установки ПО (PCID); идентификатор устройства; идентификатор учетной записи, от имени которой был запущен контролируемый процесс; идентификатор уязвимости; идентификаторы выполненных команд; имя и параметры владельца сертификата; имя компьютера в сети (доменное имя); имя обрабатываемого объекта; имя приложения, частью которого является обрабатываемый объект; информация о клиенте, использующем сетевой протокол (user agent); информация о результатах проверки подписи файла; информация о том, кем был подписан обрабатываемый объект; информация об обновлениях ПО; источник заключения по обрабатываемому объекту; источник хоста; класс опасности уязвимости; ключ сеанса входа; алгоритм шифрования ключа сеанса входа; код каталога файлов; код категории ошибки; код ошибки; код ошибки задачи обновления; код типа объекта; код файловой операции; количество выполненных запросов к KSN; количество запросов, для которых был найден ответ в локальной базе запросов; количество запусков ПО с момента последней отправки контрольной суммы файла; количество неуспешных KSN-транзакций; количество неуспешных запросов из-за выключенного KSN в параметрах ПО; количество неуспешных запросов к KSN из-за ошибок маршрутизации; количество неуспешных запросов к KSN из-за сетевых проблем; количество неуспешных подключений к KSN; количество новых подключений к KSN; количество подключений к KSN, взятых из кеша; количество секций в PE заголовке файла; количество успешных KSN-транзакций; количество успешных подключений к KSN; командная строка запуска; контрольная сумма (MD5) маски, по которой была заблокирована веб-служба; контрольная сумма (MD5) обрабатываемого объекта; контрольная сумма (SHA256) обрабатываемого объекта; контрольная сумма кода активации ПО; контрольная сумма лицензионного тикета ПО; контрольная сумма обрабатываемого объекта; контрольная сумма обрабатываемого объекта (MD5); контрольная сумма от имени пользователя; контрольная сумма файла ключа, которым активировано ПО; локализация ПО; локальный IP адрес; локальный порт, на который была проведена атака; место внедрения кода в обрабатываемом процессе; метод осуществления http-запроса; название компонента; название компонента ПО; название обнаруженной вредоносной программы или легальной программы, которая может быть использована для нанесения вреда устройству или данным пользователя; название ПО; название продавца ПО; название сетевого протокола, используемого в обнаруженной сетевой атаке; название созданной/измененной службы ОС; названия упаковщиков, которыми был упакован обрабатываемый объект; наименование эмитента сертификата; направление сетевого подключения; номер обнаруженного ПО в контексте компонента мониторинг активности; номер порта; область действия, к которой принадлежит IP-адрес; обнаруженные файловые операции, выполненные над обрабатываемым объектом; обрабатываемые объекты или их части; обрабатываемый веб-адрес; описание обрабатываемого объекта, указанное в его свойствах; ответ DNS-сервера; отпечаток цифрового сертификата проверяемого объекта и алгоритм хеширования; полная версия ПО; порядковый номер фрагмента в обрабатываемом объекте; права доступа, которыми обладает обрабатываемый объект; признак доверенности проверяемого объекта по KSN; признак обрабатываемого объекта, по которому было отозвано решение по этому объекту; признак того, что обнаружение является отладочным; признак того, что обрабатываемый объект является PE-файлом; признак того, что объект находится в автозапуске; признак того, что сообщение является одним из набора сообщений, относящихся к одному обращению к веб-службе; признак участия в KSN; причина обнаружения стороннего ПО компонентом мониторинг активности; протокол, используемый для передачи данных в KSN; публичный ключ сертификата; путь к исполняемому файлу родительского процесса; путь к исходному объекту; путь к обрабатываемому объекту; размер наложения из PE заголовка файла; размер обрабатываемого объекта; размер образа приложения ; разрядность операционной системы, архитектура ОС; распределение по времени выполнения запросов к KSN, превысивших ограничение на время ожидания; распределение по времени выполнения неуспешных KSN-транзакций; распределение по времени выполнения неуспешных подключений к KSN; распределение по времени выполнения отмененных запросов к KSN; распределение по времени выполнения успешных KSN-транзакций; распределение по времени выполнения успешных запросов к KSN; распределение по времени выполнения успешных подключений к KSN; редакция ОС; результат действий, выполненных ПО; результат операции с обрабатываемым объектом; результат проверки объекта в KSN; результат проверки подписи модуля, целостность которого проверяется ПО; результат проверки сертификата; свойства и контрольные суммы частей исполняемого файла; свойства и контрольные суммы частей исполняемого файла; серийный номер лицензионного ключа ПО; серийный номер сертификата; сетевые интерфейсы компьютера; содержимое фрагмента в обрабатываемом объекте; статус лицензии, по которой используется ПО; статус работоспособности ПО после обновления; статус работы компонента ПО; степень уверенности в определении обращения к фишинговой веб-службе; технические характеристики применяемых технологий обнаружения; тип задачи обновления; тип задачи проверки исполняемого файла, в результате которой отправляется статистика; тип запроса к DNS-серверу; тип контрольной суммы обрабатываемого объекта; тип события, по которому собран пакет статистики; тип сообщения статистики; тип сработавшей записи в антивирусных базах ПО; тип установленного ПО; тип учетной записи, с правами которой был запущен возможно зараженный объект; уникальный идентификатор журнала активности обрабатываемого объекта; уникальный идентификатор пользователя в системах правообладателя; уникальный идентификатор события; уникальный идентификатор устройства; уровень целостности обрабатываемого объекта; формат данных в запросе к инфраструктуре Правообладателя; формат обрабатываемого объекта; характеристики обнаружения; характеристики шифрования пакета данных, отправляемых в KSN; цель фишинговой атаки; число неуспешных завершений установки обновления для компонента обновления; число ошибок установки обновления для компонента обновления; эвристически определенное имя email маркетера – отправителя сообщения электронной почты; энтропия обрабатываемого объекта.
Также для достижения заявленной цели в части предотвращения ложных срабатываний Правообладатель может получать доверенные исполняемые и неисполняемые файлы или их части.

Добровольное предоставление данных
Предоставление вышеуказанной информации в KSN является добровольным. После установки ПО Пользователь имеет возможность в любой момент времени включить использование KSN или отказаться от использования KSN в настройках ПО согласно описанию в Руководстве пользователя.
Когда Пользователь решает отказаться от использования KSN, Правообладатель не будет получать новые данные. Правообладатель может продолжить обрабатывать данные, которые были уже получены им на основании законного интереса согласно пункту (f) Статьи 6 (1) EU General Data Protection Regulation (GDPR) для целей, указанных в Политике Конфиденциальности https://www.kaspersky.com/products-and-services-privacy-policy. Если Пользователь хочет возразить против такой обработки данных, Пользователь должен проинформировать Правообладателя способом, указанным в Политике Конфиденциальности. Более подробная информация о законных основаниях обработки данных, правах и возможностях Пользователя указана в Политике Конфиденциальности https://www.kaspersky.com/products-and-services-privacy-policy.

© 2022 АО «Лаборатория Касперского»